-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}

local function onReset()
  electrics.values['thruster_f'] = 0
  electrics.values['thruster_f_input'] = 0
  electrics.values['thruster_b'] = 0
  electrics.values['thruster_b_input'] = 0

  electrics.values['thruster_r'] = 0
  electrics.values['thruster_r_input'] = 0
  electrics.values['thruster_l'] = 0
  electrics.values['thruster_l_input'] = 0
end

local function updateGFX(dt)
  electrics.values['thruster_f'] = math.min(1, math.max(-0.0, (electrics.values['thruster_f'] + electrics.values['thruster_f_input'] * dt * 0.2)))
  electrics.values['thruster_b'] = math.min(1, math.max(-0.0, (electrics.values['thruster_b'] + electrics.values['thruster_b_input'] * dt * 0.2)))
  electrics.values['thruster_r'] = math.min(1, math.max(-0.0, (electrics.values['thruster_r'] + electrics.values['thruster_r_input'] * dt * 0.2)))
  electrics.values['thruster_l'] = math.min(1, math.max(-0.0, (electrics.values['thruster_l'] + electrics.values['thruster_l_input'] * dt * 0.2)))
end

local function thruster_f(value)
  electrics.values.thruster_b = value*0
  electrics.values.thruster_f_input = value
end

local function thruster_b(value)
  electrics.values.thruster_f = value*0
  electrics.values.thruster_b_input = value
end

local function thruster_r(value)
  electrics.values.thruster_l_input = 0
  electrics.values.thruster_r_input = value
end

local function thruster_l(value)
  electrics.values.thruster_r_input = 0
  electrics.values.thruster_l_input = value
end

-- public interface
M.onInit    = onReset
M.onReset   = onReset
M.updateGFX = updateGFX
M.thruster_f = thruster_f
M.thruster_b = thruster_b
M.thruster_r = thruster_r
M.thruster_l = thruster_l

return M
